SystemOrganization addCategory: #Rest!

Object subclass: #RestHttpRequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest'!

!RestHttpRequestHandler methodsFor: 'request processing' stamp: 'mt 2/14/2009 14:26'!
process: anHttpRequest
	"Takes second element in path as classname and sends message from third path element to that class."

	|pc class selector result|
	pc := (URI fromString: anHttpRequest url) pathComponents.
	class := pc second asSymbol.
	selector := pc third asSymbol.
	
	Smalltalk at: class ifPresent: [:c | 
		(c class allSelectors includes: selector) ifTrue: [
			result := c perform: selector]].

	^ HttpResponse fromString: result printString.! !

Object subclass: #RestLogService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest'!

!RestLogService class methodsFor: 'service' stamp: 'cs 2/7/2009 14:20'!
log: aCollection
	Transcript show: aCollection first asString; cr.! !

HttpService subclass: #RestHttpService
	instanceVariableNames: 'handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest'!

RestHttpService class
	instanceVariableNames: 'service port'!

RestHttpService class
	instanceVariableNames: 'service port'!

!RestHttpService class methodsFor: 'as yet unclassified' stamp: 'mt 2/14/2009 14:25'!
createService
	^ RestHttpService on: (self port).! !

!RestHttpService class methodsFor: 'as yet unclassified' stamp: 'bs 2/13/2009 15:06'!
port
	^8082! !

!RestHttpService class methodsFor: 'as yet unclassified' stamp: 'mt 2/14/2009 14:25'!
run
	self stop.
	
	service := self createService.
	service
		installHandler: RestHttpRequestHandler on: '/rest';
		start.! !

!RestHttpService class methodsFor: 'as yet unclassified' stamp: 'mt 1/30/2009 13:28'!
stop
	service ifNotNil:
		[service unregister.
		service := nil].
	port := nil.! !

!RestHttpService methodsFor: 'as yet unclassified' stamp: 'mt 2/2/2009 10:12'!
initialize
	super initialize.
	handlers := OrderedCollection new	"needed for priorities"! !

!RestHttpService methodsFor: 'as yet unclassified' stamp: 'mt 2/2/2009 10:12'!
installHandler: aRequestHandlerClass on: aPathString 
	handlers add: aPathString -> aRequestHandlerClass! !

!RestHttpService methodsFor: 'as yet unclassified' stamp: 'mt 2/2/2009 10:27'!
processHttpRequest: request
	
	| activeHandler path |
	activeHandler := (handlers detect: [:ass| 
		path := ass key.
		request url includesSubString: path
		]) value.
	^(activeHandler new) process: request! !

TestCase subclass: #RestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest'!

!RestTest methodsFor: 'as yet unclassified' stamp: 'bs 2/13/2009 15:27'!
testGetUserStories
	HTTPClient httpGet: 'http://localhost:8082/rest'! !
